com.google.cloud.dataflow.sdk.io

## Class PubsubIO.Write.Bound<T>

- java.lang.Object
- - com.google.cloud.dataflow.sdk.transforms.PTransform<PCollection<T>,PDone>
  - - com.google.cloud.dataflow.sdk.io.PubsubIO.Write.Bound<T>

All Implemented Interfaces:
  HasDisplayData, Serializable

Enclosing class:
  PubsubIO.Write

    public static class PubsubIO.Write.Bound<T>
    extends PTransform<PCollection<T>,PDone>

A `PTransform` that writes an unbounded `PCollection` of `Strings` to a Cloud Pub/Sub stream.

See Also:
  Serialized Form

### Nested Class Summary

Nested Classes
`class` `PubsubIO.Write.Bound.PubsubWriter` Writer to Pubsub which batches messages from bounded collections.

### Field Summary

### Fields inherited from class com.google.cloud.dataflow.sdk.transforms.PTransform

`name`

### Method Summary

All Methods Instance Methods Concrete Methods
`PDone` `apply(PCollection<T> input)` Applies this `PTransform` on the given `InputT`, and returns its `Output`.
`Coder<T>` `getCoder()`
`protected Coder<Void>` `getDefaultOutputCoder()` Returns the default `Coder` to use for the output of this single-output `PTransform`.
`String` `getIdLabel()`
`String` `getTimestampLabel()`
`PubsubIO.PubsubTopic` `getTopic()`
`PubsubIO.Write.Bound<T>` `idLabel(String idLabel)` Returns a new transform that's like this one but that publishes unique record IDs to a message attribute with the specified name.
`PubsubIO.Write.Bound<T>` `named(String name)` Returns a new transform that's like this one but with the specified step name.
`void` `populateDisplayData(DisplayData.Builder builder)` Register display data for the given transform or component.
`PubsubIO.Write.Bound<T>` `timestampLabel(String timestampLabel)` Returns a new transform that's like this one but that publishes record timestamps to a message attribute with the specified name.
`PubsubIO.Write.Bound<T>` `topic(String topic)` Returns a new transform that's like this one but that writes to the specified topic.
`<X> PubsubIO.Write.Bound<X>` `withCoder(Coder<X> coder)` Returns a new transform that's like this one but that uses the given `Coder` to encode each of the elements of the input `PCollection` into an output record.

### Methods inherited from class com.google.cloud.dataflow.sdk.transforms.PTransform

`getDefaultOutputCoder, getDefaultOutputCoder, getKindString, getName, toString, validate`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Method Detail

#### named

    public PubsubIO.Write.Bound<T> named(String name)

Returns a new transform that's like this one but with the specified step name.

Does not modify this object.

#### topic

    public PubsubIO.Write.Bound<T> topic(String topic)

Returns a new transform that's like this one but that writes to the specified topic.

See `PubsubIO.PubsubTopic.fromPath(String)` for more details on the format of the `topic` string.

Does not modify this object.

#### timestampLabel

    public PubsubIO.Write.Bound<T> timestampLabel(String timestampLabel)

Returns a new transform that's like this one but that publishes record timestamps to a message attribute with the specified name. See `PubsubIO.Write.timestampLabel(String)` for more details.

Does not modify this object.

#### idLabel

    public PubsubIO.Write.Bound<T> idLabel(String idLabel)

Returns a new transform that's like this one but that publishes unique record IDs to a message attribute with the specified name. See `PubsubIO.Write.idLabel(String)` for more details.

Does not modify this object.

#### withCoder

    public <X> PubsubIO.Write.Bound<X> withCoder(Coder<X> coder)

Returns a new transform that's like this one but that uses the given `Coder` to encode each of the elements of the input `PCollection` into an output record.

Does not modify this object.

Type Parameters:
  `X` - the type of the elements of the input `PCollection`

#### apply

    public PDone apply(PCollection<T> input)

Description copied from class: `PTransform`
Applies this `PTransform` on the given `InputT`, and returns its `Output`.

Composite transforms, which are defined in terms of other transforms, should return the output of one of the composed transforms. Non-composite transforms, which do not apply any transforms internally, should return a new unbound output and register evaluators (via backend-specific registration methods).

The default implementation throws an exception. A derived class must either implement apply, or else each runner must supply a custom implementation via `PipelineRunner.apply(com.google.cloud.dataflow.sdk.transforms.PTransform<InputT, OutputT>, InputT)`.

Overrides:
  `apply` in class `PTransform<PCollection<T>,PDone>`

#### populateDisplayData

    public void populateDisplayData(DisplayData.Builder builder)

Description copied from class: `PTransform`
Register display data for the given transform or component.

`populateDisplayData(DisplayData.Builder)` is invoked by Pipeline runners to collect display data via `DisplayData.from(HasDisplayData)`. Implementations may call `super.populateDisplayData(builder)` in order to register display data in the current namespace, but should otherwise use `subcomponent.populateDisplayData(builder)` to use the namespace of the subcomponent.

By default, does not register any display data. Implementors may override this method to provide their own display data.

Specified by:
  `populateDisplayData` in interface `HasDisplayData`
Overrides:
  `populateDisplayData` in class `PTransform<PCollection<T>,PDone>`
Parameters:
  `builder` - The builder to populate with display data.
See Also:
  `HasDisplayData`

#### getDefaultOutputCoder

    protected Coder<Void> getDefaultOutputCoder()

Description copied from class: `PTransform`
Returns the default `Coder` to use for the output of this single-output `PTransform`.

By default, always throws

Overrides:
  `getDefaultOutputCoder` in class `PTransform<PCollection<T>,PDone>`

#### getTopic

    public PubsubIO.PubsubTopic getTopic()

#### getTimestampLabel

    public String getTimestampLabel()

#### getIdLabel

    public String getIdLabel()

#### getCoder

    public Coder<T> getCoder()